--[[ **POST-MATCH** ]]

Import "PlayerDialogueScripts.lua"

Using "StarPulse"
Using "StarLineConnector"
Using "Goal02"
Using "Foreground_VignetteTest"

Using "SigilNightwings"
Using "SigilAccusers"
Using "SigilBeyonders"

-- Victory Screen VFX
Using "VictoryScreen"
Using "VictoryRaysGraphicA"
Using "VictoryRaysGraphicB"
Using "VictoryRaysGraphicC"
Using "VictoryCornerSymbolR"
Using "VictoryCornerSymbolL"
Using "VictoryTextBacking"
Using "VictoryNameFlare"
Using "VictoryScreenBottomRibbon"
Using "Halo02_victory"
Using "Foreground_VignetteTest"
Using "VictorySparkles"
Using "VictoryTextWeathering"
Using "SparkleFlakesRadial"
Using "FootstepRipple"
Using "FootstepSplashRandom"


-- Fake Post Match Screen

OnKeyPressed{ "Control F9", Name = "CommencePostMatch",
	function( triggerArgs )

		SetConfigOption({ Name = "PlayerTwoAI", Value = false })

		for key, char in pairs( PlayerTeam.TeamBench ) do
			char.RosterStatus = "Active"
		end

		if TeamA.PyreHealth == TeamA.PyreMaxHealth and TeamB.PyreHealth == TeamB.PyreMaxHealth then
			TeamB.PyreHealth = 0
		end

		RecordMatch( TeamA.LeagueIndex, TeamB.LeagueIndex )
		CommencePostMatch()
	end
}

function CommencePostMatch()

	postMatchScreen = true
	SetFlagTrue({ Name = "PostMatch" })

	StopSound({ Name = "/Ambience/StarPickerAmbienceLoop", Duration = 3.0 })

	DisableInput({ PlayerIndex = 1 })
	--DisableInput({ PlayerIndex = 2 })

	-- Music
	if not ascensionMatch then
		FadeMusicOut({ Duration = 0.0 })
		if LastTeam.LeagueIndex ~= 11 and not forfeitMatch then
			MusicPlayer( "/Music/UrsaIdea9" )
			if PlayerTeam.TeamLastMatchResult == "Win" then
				SetSoundCueValue({ Names = { "Win" }, Id = GetMusicId({ }), Value = 1 })
			else
				SetSoundCueValue({ Names = { "Loss" }, Id = GetMusicId({ }), Value = 1 })
			end
		end
	else
		-- Ascension Match music scripting special cases
		UpdateMatchMusic( "nopossession" )
		PlaySound({ Name = "/Music/OvermapMusicINTRO" })
		blockMusicChanges = true
		blockMatchVO = true
	end

	hideEntireUI()

	ClearCameraClamp({  })
	HideMatchUI()
	RemoveWorldText({ DestinationNames = { "GoalA", "GoalB" } })
	LockCamera({ Id = ballId, OffsetX = 0, OffsetY = 0 })

	--wait(0.2)
	OpenMenu({ Name = "RosterScreen", StyleXML = "RosterScreen" })

	-- Disable non-relevant RosterScreen components
	-- SetMenuOptions({ Name = "RosterScreen", Item = "BioTab", Properties = { IsVisible = false, Enabled = false } })
	-- SetMenuOptions({ Name = "RosterScreen", Item = "Back", Properties = { IsVisible = false, Enabled = false } })
	SetMenuOptions({ Name = "RosterScreen", Item = "BioTab", Properties = { Graphic = "GUI\\Screens\\DetailsButton_Bio_Unavailable", Enabled = false, TooltipId = "Roster_OpenBio_Disabled_PostMatch" } })
	SetMenuOptions({ Name = "RosterScreen", Item = "SkillsTab", Properties = { Graphic = "GUI\\Screens\\DetailsButton_Skills_Unavailable", Enabled = false, TooltipId = "Roster_OpenSkills_Disabled_PostMatch" } })
	SetMenuOptions({ Name = "RosterScreen", Item = "InventoryTab", Properties = { Graphic = "GUI\\Screens\\DetailsButton_Talisman_Unavailable", Enabled = false, TooltipId = "Roster_OpenInventory_Disabled_PostMatch" } })
	SetMenuOptions({ Name = "RosterScreen", Item = "Background", Properties = { IsVisible = false } })

	SetMenuOptions({ Name = "RosterScreen", Item = "LeftArrow", Properties = { IsVisible = false, Enabled = false, FadeTarget = 0.0  } })
	SetMenuOptions({ Name = "RosterScreen", Item = "RightArrow", Properties = { IsVisible = false, Enabled = false, FadeTarget = 0.0 } })
	SetMenuOptions({ Name = "RosterScreen", Properties = { Run = "DisablePortraitGrid" } })
	SetMenuOptions({ Name = "RosterScreen", Item = "CancelButton", Properties = { IsVisible = false, FadeTarget = 0.0 } })
	SetMenuOptions({ Name = "RosterScreen", Item = "ConfirmButton", Properties = { IsVisible = false, FadeTarget = 0.0 } })

	SetMenuOptions({ Name = "RosterScreen", Properties = { Run = "StartForceXP" } })
	SetMenuOptions({ Name = "RosterScreen", Item = "LeftArrow", Properties = { IsVisible = false, Enabled = false } })
	SetMenuOptions({ Name = "RosterScreen", Item = "RightArrow", Properties = { IsVisible = false, Enabled = false } })
	SetMenuOptions({ Name = "RosterScreen", Properties = { Run = "DisablePortraitGrid" } })

	wait(0.5)
	if TeamA.TeamLastMatchResult == "Win" then
		GivePostMatchXP( TeamA.TeamBench, PostMatchWinXP )
	else
		GivePostMatchXP( TeamA.TeamBench, PostMatchLossXP )
	end
	GivePostMatchXPSilent( TeamB.TeamBench, PostMatchWinXP )

	--thread( PostMatchAudio )
end

function GivePostMatchXP( teamBench, grantedXP )

	thread( PostMatchBeginsAudio )

	-- stop bonfire/aura sounds if you are standing next to them when you level up
	StopSound({ Name = "/SFX/Menu Sounds/ChoirLoop" })
	StopSound({ Name = "/SFX/Match SFX/FireAmbientLoopMATCH" })
	StopSound({ Name = "/SFX/Match SFX/FireAmbientLoop" })
	StopSound({ Name = "/SFX/Match SFX/FireAmbientLoopMATCH_2" })

	for index, playerTable in ipairs( teamBench ) do

		if playerTable.RosterStatus == "Active" then

			RosterScreenForcedTarget = playerTable
			SetMenuOptions({ Name = "RosterScreen", Properties = { Run = "CycleToForcedTarget" } })
			wait(0.5)
			SetMenuOptions({ Name = "RosterScreen", Properties = { Run = "NextPostMatch" } })

			if playerTable.ActiveStatus == "PlayedLastMatch" and not forfeitMatch then
				playerTable.MatchesPlayed = playerTable.MatchesPlayed + 1
				SetMenuOptions({ Name = "RosterScreen", Properties = { Run = "StartForceXP" } })
				SetMenuOptions({ Name = "RosterScreen", Properties = { Run = "PresentUpdatedXp" } })
				SetMenuOptions({ Name = "RosterScreen", Properties = { Run = "PresentUpdatedLevel" } })
				SetMenuOptions({ Name = "CharacterSkillsScreen", Properties = { Run = "PresentUpdatedSkillPoints" } })
				wait(0.5)
				GiveXPWithPresentation( playerTable, grantedXP )
				wait(0.50)
			else
				if CharacterXPEligible( playerTable ) then
					GiveRest(playerTable)
				end
			end
		end

	end

	SetMenuOptions({ Name = "RosterScreen", Properties = { Run = "EndForceXP" } })
	SetMenuOptions({ Name = "RosterScreen", Item = "CancelButton", Properties = { IsVisible = true, FadeTarget = 1.0 } })

	wait(3)
	CheckExitPostMatchTutorial()

end

function GiveRest( playerTable )
	-- Did not participate
	wait(0.05)
	-- set selected character here so these infopanels work
	UnPlayedCharacter = playerTable
	AdvanceRestState( playerTable )
	local restXpTime = 0.85
	if matchesPlayed >= 4 then
		SetMenuOptions({ Name = "RosterScreen", Item = "XpBarRest", Properties = { WidthChangeSpeed = 0.2 } })
		restXpTime = 0.4
	end
	SetMenuOptions({ Name = "RosterScreen", Properties = { Run = "StartForceXP" } })
	SetMenuOptions({ Name = "RosterScreen", Properties = { Run = "PresentUpdatedXp" } })
	PlaySound({ Name = "/SFX/Menu Sounds/GuideBookChapterUnlock" })
	thread( PlayerRestedAudio )
	wait(restXpTime)
end

function GivePostMatchXPSilent( teamBench, grantedXp )

	for index, playerTable in ipairs( teamBench ) do

		if playerTable["ActiveStatus"] == "PlayedLastMatch" then
			playerTable.MatchesPlayed = playerTable.MatchesPlayed + 1
			GiveXP( playerTable, grantedXp )
		end

	end

end

function CheckExitPostMatchTutorial()
	if exitPostMatchTutorial then
		return
	end
	if matchesPlayed > 1 then
		return
	end
	if blockExitTutorialBox then
		return
	end
	exitPostMatchTutorial = true
	PersistVariable({ Name = "exitPostMatchTutorial" })
	DisplayTutorialBox({ HelpTextId = "Info_ExitPostMatch", X = 1388, Y = 964, Animation = "TutorialBoxSmallIn", Arrow = "Right" })

end

OnMenuCloseFinished{ "RosterScreen",
	RequiredFlag = "PostMatch",
	function( triggerArgs )

		if not postMatchScreen then
			return
		end
		blockExitTutorialBox = true
		if CurrentTutorialBox == "Info_ExitPostMatch" then
			HideTutorialBox()
		end
		waitScreenTime(0.01)
		postMatchScreen = false
		SetFlagFalse({ Name = "PostMatch" })

		if matchesPlayed > 1 then
			-- Ascension Match music scripting
			if ascensionMatch then
				blockMatchVO = false
				blockMusicChanges = false
				StopSound({ Name = "/Music/OvermapMusicINTRO", Duration = 0.5 })
			end
			FireTrigger({ Name = "EndCurrentMusic" })
		end

		if not IsFirstAccusersMatch() then
			thread( MatchSendOffAudio )
		end

		waitScreenTime(0.25)
		DisableInput({ PlayerIndex = 1 })
		waitScreenTime(0.15)
		FadeOut({ Color = Color.Black, Duration = 0.3 })

		-- **Match_Conclusion Events / Match Conclusion Events**
		if matchesPlayed == 1 then
			NarrationSequence( "Intro_Week1_Match_Conclusion" )
		-- Week 2: Spring match
		elseif matchesPlayed == 2 and GetMapName({ }) == "MatchSiteC" then
			NarrationSequence( "Week2_Match_Conclusion" )
		-- Week 3: Cairn match
		elseif matchesPlayed == 3 and GetMapName({ }) == "MatchSiteD" then
			if lastMatchResult == "Win" then
				NarrationSequence( "Week3_Match_Conclusion_YouWon" )
			else
				NarrationSequence( "Week3_Match_Conclusion_YouLost" )
			end
		-- Week 7: Woods / Glade match
		elseif matchesPlayed < 8 and GetMapName({ }) == "MatchSiteH" then
			if lastMatchResult == "Win" then
				NarrationSequence( "Week7_Match_Conclusion_YouWon" )
			else
				NarrationSequence( "Week7_Match_Conclusion_YouLost" )
			end
		-- Open Structure
		elseif PlayerTeam.AscensionMatchesPlayed >= 1 then
			-- Jodi + Pamitha subplot - postmatch result
			if not ascensionMatch and not practiceMatch then
				if GetNumTimesDraftedTogether( PlayerTeam, CharBadass, CharVamp ) == 1 then
					if CharBadass.ActiveStatus == "PlayedLastMatch" and CharVamp.ActiveStatus == "PlayedLastMatch" then
						if lastMatchResult == "Win" then
							if not NarrationRecord["Match_Conclusion_JodiPamitha_YouLost"] then
								NarrationSequenceOnce( "Match_Conclusion_JodiPamitha_YouWon" )
							end
						else
							if not NarrationRecord["Match_Conclusion_JodiPamitha_YouWon"] then
								NarrationSequenceOnce( "Match_Conclusion_JodiPamitha_YouLost" )
							end
						end
					end
				-- Jodi + Ignarius match conclusion event
				elseif not IsEmpty( LastTeam["RivalryMatchConclusionEvents"] ) and IsRivalryPresent( LastTeam ) then
					eventName = RemoveFirstIndexValue( LastTeam["RivalryMatchConclusionEvents"] )
					NarrationSequence( eventName )
				end
			-- Ascension rivalry conclusion events
			elseif ascensionMatch then
				-- Pamitha vs. Essence & Mae vs. Fate ascension match conclusion events
				if lastMatchResult == "Win" then
					if not IsEmpty( LastTeam["RivalryAscensionConclusionEventsPlayerWon"] ) then
						if IsRivalryPresent( LastTeam ) or DidRivalJustAscend( LastTeam ) then
							-- Essence: variant if Pamitha is not the ascended character
							if LastTeam == League[7] and LastAscendedCharacter ~= CharVamp then
								eventName = "Ascension_Conclusion_PlayerWon_Rivalry_Essence_Alt"
								NarrationSequence( eventName )
							else
								eventName = RemoveFirstIndexValue( LastTeam["RivalryAscensionConclusionEventsPlayerWon"] )
								NarrationSequence( eventName )
							end
						end
					end
				else
					if not IsEmpty( LastTeam["RivalryAscensionConclusionEventsPlayerLost"] ) and IsRivalryPresent( LastTeam ) then
						eventName = RemoveFirstIndexValue( LastTeam["RivalryAscensionConclusionEventsPlayerLost"] )
						NarrationSequence( eventName )
					end
				end
			end
		else
			FireTrigger({ Name = "EndCurrentMusic" })
		end

		if ascensionMatch then
			FireTrigger({ Name = "EndCurrentMusic" })
		end

		FadeOutAllAmbience( 1.5 )

		SetConfigOption({ Name = "AllowPause", Value = false })

		if introMatch then
			SaveProfile({ ShowSaveSpinner = false })
		end

		wait(0.25)

		StartNewWeek()

		-- stop misc. persistent sounds from carrying over
		StopSound({ Name = "/Ambience/RainAmbience", Duration = 0.5 })
		wait(1.5)
		SetConfigOption({ Name = "KillSpeechOnLoad", Value = false })
		SaveCheckpoint({ StartNextMap = "Campaign", DevSaveName = CreateReturnDevSaveName() })
		SetConfigOption({ Name = "AllowPause", Value = true })
		LoadMap({ Name = "Campaign" })

	end
}

function AdvanceRestState( character )

	local RestXpPerMatch = 250
	character.RestXp = character.RestXp + RestXpPerMatch
	local RestXpCap = 10000
	if character.RestXp > RestXpCap then
		character.RestXp = RestXpCap
	end

end

-- this is used to fine-tune VO timing with respect to the battle-cry emotes and accompanying VFX at match end
function GetPostMatchVictoryEmoteDelay()
	if ascensionMatch then
		return 1
	else
		return 0
	end
end

-- Post-Match Victory/Loss Presentation
function MatchConclusionPresentation( team )

	HideMatchUI()
	if raining then
		RainStop()
	end

	ConcludingBench = team.TeamBench

	local teamGraphic = team.PostMatchSigil
	if teamGraphic == nil then
		teamGraphic = "SigilAccusers"
	end

	local matchConclusionCenter = SpawnObstacle({ Name = "InvisibleTarget", Group = "MatchConclusionScripting", DestinationName = "Player" })
	DrawScreenRelative({ Id = matchConclusionCenter })
	Teleport({ Id = matchConclusionCenter, OffsetX = 1920/2, OffsetY = 1080/2 })

	-- Color Grading & Bloom
	if ascensionMatch then
		AdjustColorGrading({ Name = "Ascension", Duration = 0.2 })
		AdjustFullscreenBloom({ Name = "AscensionVictoryBloom", Duration = 0.2  })
		ascensionGradient = SpawnObstacle({ Name = "BasicGlow", DestinationId = matchConclusionCenter, Group="VictorySmoke" })
		SetScale({ Id = ascensionGradient, Fraction = 3 })
		MakeScreenRelativeAndCenter( { ascensionGradient }, matchConclusionCenter, 0, 400 )
	else
		AdjustColorGrading({ Name = "Scoring", Duration = 0.25 })
		AdjustColorGrading({ Name = "Off", Duration = 1 })
		AdjustFullscreenBloom({ Name = "TestJosh", Duration = 0.2 })
	end

	-- to get NightSky to look better
	MovingHoldCamera({ Enabled = true, Range = { 30, 5 }, Delay = 3 })

	-- halo02 (outer symbols)
	symbols = SpawnObstacle({ Name = "Halo02_Victory", DestinationId = matchConclusionCenter, Group="VictorySymbols" })
	MakeScreenRelativeAndCenter( { symbols }, matchConclusionCenter )

	-- graphic rays
	raysA = SpawnObstacle({ Name = "VictoryRaysA", DestinationId = matchConclusionCenter, Group="VictoryRays" })
	raysB = SpawnObstacle({ Name = "VictoryRaysB", DestinationId = matchConclusionCenter, Group="VictoryRays" })
	raysC = SpawnObstacle({ Name = "VictoryRaysC", DestinationId = matchConclusionCenter, Group="VictoryRays" })
	MakeScreenRelativeAndCenter( { raysA, raysB, raysC }, matchConclusionCenter )
	--InsertGroupBehind({ Name = "VictoryRays", DestinationName = "VictorySymbols" })

	SetScale({ Id = raysA, Fraction = 0, Duration = 0 })
	SetScale({ Id = raysB, Fraction = 0, Duration = 0 })
	SetScale({ Id = raysC, Fraction = 0, Duration = 0 })

	SetScale({ Id = raysA, Fraction = 1, Duration = 0.25 })
	SetScale({ Id = raysB, Fraction = 1, Duration = 0.35 })
	SetScale({ Id = raysC, Fraction = 1, Duration = 0.45 })

	-- spawn appropriate team sigil
	sigil = SpawnObstacle({ Name = teamGraphic, DestinationId = matchConclusionCenter, Group="VictoryTeamSigil"})
	SetScale({ Id = sigil, Fraction = 1.2, Duration = 0 })
	SetScale({ Id = sigil, Fraction = 1.1, Duration = 8 })
	SetColor({ Id = sigil, Color = {0,0,0,255}, Duration = 0 })
	SetColor({ Id = sigil, Color = {255,255,255,255}, Duration = 0.6, Delay=0.15 })
	MakeScreenRelativeAndCenter( { sigil }, matchConclusionCenter )
	InsertGroupInFront({ Name = "VictoryTeamSigil", DestinationName = "VictoryRays" })

	-- victory screen vfx
	victoryScreenLoop = SpawnObstacle({ Name = "VictoryScreenLoop", DestinationId = matchConclusionCenter, Group="VictoryScreenVFX"})
	MakeScreenRelativeAndCenter( { victoryScreenLoop }, matchConclusionCenter )
	--InsertGroupBehind({ Name = "VictoryScreenVFX", DestinationName = "VictoryRays" })

	-- victory screen SFX
	PlaySound({ Name = "/SFX/Match SFX/VictoryScreenUpdateSFX" })

	-- corner symbols
	wait(0.2)
	AdjustFullscreenBloom({ Name = "Off", Duration = 0.5 })

	victoryCornerSymbolL = SpawnObstacle({ Name = "VictoryCornerSymbolL", DestinationId = matchConclusionCenter, Group="VictorySymbols" })
	victoryCornerSymbolR = SpawnObstacle({ Name = "VictoryCornerSymbolR", DestinationId = matchConclusionCenter, Group="VictorySymbols" })
	MakeScreenRelativeAndCenter( { victoryCornerSymbolL }, matchConclusionCenter, -827, 350 )
	MakeScreenRelativeAndCenter( { victoryCornerSymbolR }, matchConclusionCenter, 824, 350 )

	-- set team PRIMARY color for victoryCornerSymbols
	SetColor({ Ids = {victoryCornerSymbolR, victoryCornerSymbolL}, Color = team.MaskHueRGB, Duration = 0})

	-- sparkles
	local animationA = "VictorySparkles"
	local animationB = "VictorySparkles"
	local animationC = "SparkleFlakesRadial"
	if ascensionMatch then
		animationA = "VictorySparklesAscension"
		animationA = "VictorySparklesAscension"
		animationC = "SparkleFlakesRadialAscension"
	end

	victorySparklesA = SpawnObstacle({ Name = animationA, DestinationId = matchConclusionCenter, Group="VictorySparkles" })
	victorySparklesB = SpawnObstacle({ Name = animationB, DestinationId = matchConclusionCenter, Group="VictorySparkles" })
	victorySparklesC = SpawnObstacle({ Name = animationC, DestinationId = matchConclusionCenter, Group="VictorySparkles"})
	MakeScreenRelativeAndCenter( {  victorySparklesA }, matchConclusionCenter, 0, -50 )
	MakeScreenRelativeAndCenter( {  victorySparklesB, victorySparklesC }, matchConclusionCenter )
	--InsertGroupBehind({ Name = "VictorySparkles", DestinationName = "VictoryScreenVFX" })

	-- set team colors for sparkle spawners
	SetColor({ Id = victorySparklesA, Color = team.MaskHueRGB, Duration = 0}) -- team PRIMARY color for sparklesA
	SetColor({ Id = victorySparklesB, Color = team.MaskHueRGB2, Duration = 0}) -- team SECONDARY color for sparklesB

	-- Insert Characters Here --

	-- smoke
	victorySmoke = SpawnObstacle({ Name = "VictorySmoke", DestinationId = matchConclusionCenter, Group="VictorySmoke" })
	-- set PRIMARY team color for smoke
	SetColor({ Id = victorySmoke, Color = team.MaskHueRGB, Duration = 0})
	SetOpacity({ Id = victorySmoke, Fraction = 0, Duration = 0})
	SetOpacity({ Id = victorySmoke, Fraction = 1, Duration = 0.25, Delay = 0.33})
	MakeScreenRelativeAndCenter( { victorySmoke }, matchConclusionCenter )

	-- vignette
	victoryVignette = SpawnObstacle({ Name = "Foreground_VignetteTest", DestinationId = matchConclusionCenter, Group="VictoryVignette" })
	SetColor({ Id = victoryVignette , Color = {0,0,0,255}, Duration = 0})
	SetScale({ Id = victoryVignette, Fraction = 2.02 })
	SetOpacity({ Id = victoryVignette, Fraction = 0.66 })
	MakeScreenRelativeAndCenter( { victoryVignette }, matchConclusionCenter, 0, 400 )

	wait(0.5)

	-- darken sigil after 0.5 seconds
	SetColor({ Id = sigil, Color = {64,64,64,255}, Duration = 1.5  })

	-- text backing
	victoryTextBacking = SpawnObstacle({ Name = "VictoryTextBacking", DestinationId = matchConclusionCenter, Group="VictoryText" })
	victoryTextAnchor = SpawnObstacle({ Name = "InvisibleTarget", DestinationId = matchConclusionCenter, Group="VictoryTextFlare"})
	MakeScreenRelativeAndCenter( { victoryTextBacking, victoryTextAnchor }, matchConclusionCenter, 0, 400 )

	victoryNameFlare = PlayOverheadAnimation({ Name = "VictoryNameFlare", DestinationId = victoryTextAnchor, IgnoreOverheatOffset = true })

	wait(0.12)
	-- front ribbon
	victoryRibbon = SpawnObstacle({ Name = "VictoryScreenBottomRibbon", DestinationId = matchConclusionCenter, Group="VictorySmoke", OffsetY = -500 })
	-- set SECONDARY team color for ribbon
	SetColor({ Id = victoryRibbon, Color = team.MaskHueRGB2, Duration = 0})

	MakeScreenRelativeAndCenter( { victoryRibbon }, matchConclusionCenter, 0, 500 )

	wait(0.14)

	-- Banner Text
	local bannerText = team.TeamName
	if ChallengeCharacter ~= nil then
		if team == PlayerTeam then
			bannerText = ChallengeCharacter.ShortName
		else
			local characterData = GetCharacterDataByStoryTag( "Story_Beyonder" )
			bannerText = characterData.ShortName
		end
	end

	local alwaysLowerCase = true
	if GetLanguage({ }) == "ru" then
		alwaysLowerCase = false -- Russian loc team believed capital letters would look better on this screen -- Russian loc team believed capital letters would look better on this screen
	end
	DisplayWorldText({ Text = bannerText, Id = victoryTextAnchor,
				OffsetX = 0,
				OffsetY = 0,
				Color = {210, 208, 206, 255},
				Font = "DKNorthumbria72",
				Justification = "Center",
				AlwaysLowerCase = alwaysLowerCase,
				Group = "VictoryText",
				DynamicLineScaleWidth = 956,
				})

	victoryTextWeathering = SpawnObstacle({ Name = "VictoryTextWeathering", DestinationId = matchConclusionCenter, Group = "VictoryTextWeathering" })
	MakeScreenRelativeAndCenter( { victoryTextWeathering }, matchConclusionCenter, 0, 395 )

	VictoryScreenElements = {
		victoryTextWeathering,
		victoryRibbon,
		victoryTextBacking,
		victoryVignette,
		victorySmoke,
		victorySparklesB, victorySparklesA,
		victoryCornerSymbolR, victoryCornerSymbolL,
		victoryScreenLoop,
		raysC, raysB, raysA,
		symbols,
		sigil
	}

	-- victory or defeat sign

	-- remove mask filter
	thread(ToggleVocalsState)

	if team == LocalTeam then
		PlaySound({ Name = "/Music/Stingers/EnemyScore" })
	else
		PlaySound({ Name = "/Music/Stingers/MandolinStingerMisc1" })
	end

	OpenMenu({ Name = "PostMatchScreen" })

	local charactersToDisplay = {}

	-- for Challenge matches
	if ChallengeData ~= nil then
		if team == PlayerTeam then
			-- get the Challenge Character alone
			table.insert( charactersToDisplay, ChallengeCharacter )
		else
			-- show Sandra alone if you fail a Challenge match
			local characterData = GetCharacterDataByStoryTag( "Story_Beyonder" )
			table.insert( charactersToDisplay, characterData )
		end
	-- for standard matches
	else
		for k, characterData in pairs( team.TeamBench ) do
			if characterData.ActiveStatus == "PlayedLastMatch" then
				table.insert( charactersToDisplay, characterData )
			end
		end
	end

	local tallestCharacter = RemoveTallestCharacter( charactersToDisplay )
	AssignCharacterPostMatchSlot( team, tallestCharacter, 1 )

	tallestCharacter = RemoveTallestCharacter( charactersToDisplay )
	AssignCharacterPostMatchSlot( team, tallestCharacter, 2 )

	tallestCharacter = RemoveTallestCharacter( charactersToDisplay )
	AssignCharacterPostMatchSlot( team, tallestCharacter, 3 )

	Rumble({ Fraction = 0.18, Duration = 0.17 })

	local postMatchDelayTime = GetPostMatchVictoryEmoteDelay()
	if postMatchDelayTime ~= nil and postMatchDelayTime > 0 then
		wait( postMatchDelayTime )
	end
	thread( VictoryShake, team.MeteorColorGrade )
	if ChallengeData ~= nil and team == TeamB then
		-- Play only Sandra's emote after losing a challenge match
		thread( EmoteWinning, team.TeamBench[1] )
	else
		for k, characterData in pairs( team.TeamBench ) do
			if characterData.ActiveStatus == "PlayedLastMatch" then
				thread( EmoteWinning, characterData )
			end
		end
	end

	CheckPostMatchAchievements( team )

	if ChallengeData ~= nil then
		wait(3.0)
	else
		wait(8.5)
	end

	SetOpacity({ Id = ascensionGradient, Fraction = 0, Duration = 0.2 })
	Destroy({ Id = ascensionGradient, Delay = 0.3 })
end

function CheckPostMatchAchievements( winningTeam )

	local matchConclusion = nil
	if winningTeam == LocalTeam then
		matchConclusion = "Victory"
	else
		matchConclusion = "Defeat"
	end


	-- campaign-only
	if not IsMultiplayerMatch() then
		-- ascension
		if matchConclusion == "Defeat" and ascensionMatch then
			UnlockAchievementOnce( "AchAscensionFail" )
		elseif ascensionMatch then
			UnlockAchievementOnce( "AchAscensionWin" )
		end

		-- constellation
		if matchConclusion == "Victory" then
			CheckConstellationAchievement()
		end

		-- practice match
		if practiceMatch and ChallengeData == nil then
			UnlockAchievementOnce( "AchPracticeMatch" ) -- this is win or lose
		end

		-- perfect
		if matchConclusion ~= "Defeat" and TeamB.NumScores <= 0 and ChallengeData == nil then
			UnlockAchievementOnce( "AchPerfectWin" )
		end

		-- three scores
		if matchConclusion ~= "Defeat" and TeamA.NumScores <= 3 and ChallengeData == nil then
			UnlockAchievementOnce( "AchWinScores3" )
		end

		-- story: pamitha & jodi
		if matchConclusion == "Victory" and CharVamp.ActiveStatus == "PlayedLastMatch" and CharBadass.ActiveStatus == "PlayedLastMatch" then
			UnlockAchievementOnce( "AchJodiPamithaWin" )
		end

		local teamsBeaten = 0
		for k, team in pairs( League ) do
			if team.LossesVsPlayer >= 1 then
				teamsBeaten = teamsBeaten + 1
			end
		end
		if teamsBeaten >= 9 then
			UnlockAchievementOnce( "AchRivalsWinsAll" )
		end

		if TableLength( MatchSiteVictories ) >= 9 then
			UnlockAchievementOnce( "AchMatchSitesWinAll" )
		end

	else
		-- versus mode
		if IsDefaultSettings() and matchConclusion == "Victory" then
			if GetConfigOptionValue({ Name = "LocalMPDifficulty" }) == "LocalMP_VeryHard" then
				UnlockAchievementOnce( "AchVersusBrutalWin" )
				if CountConstellationsActive() >= 6 then
					UnlockAchievementOnce( "AchVersusBrutalTitan" )
				end
			end

			if GetMapName({ }) == "MatchSiteJ" and IsUsingCharacters( winningTeam, "Chars_Mascot_FirstName", "NPC_Imp", nil ) then
				UnlockAchievementOnce( "AchVersusImps" )
			end

			if IsUsingCharacters( winningTeam, "Chars_Doc_MiddleName", "Rivals_Nightwing_FirstName", "Chars_Mascot_FirstName" ) then
				UnlockAchievementOnce( "AchVersusTrueNW" )
			end

			if IsUsingCharacters( winningTeam, "Rivals_Captain17_FirstName", "Rivals_Captain13_FirstName", "Rivals_Captain07_FirstName" ) then
				UnlockAchievementOnce( "AchVersusWitches" )
			end

			if IsUsingCharacters( winningTeam, "Chars_Joker_FirstName_LocalMP", "Rivals_FateDad_FirstName", "Rivals_Captain14_FirstName" ) then
				UnlockAchievementOnce( "AchVersusCurs" )
			end

			if winningTeam.PyreHealth <= 9 then
				UnlockAchievementOnce( "AchVersusWinAll" )
			end

		end

		if GetConfigOptionValue({ Name = "LocalMPHumanTeamA" }) then
			if GetConfigOptionValue({ Name = "LocalMPHumanTeamB" }) then
				UnlockAchievementOnce( "AchVersusHuman" )
			else
				UnlockAchievementOnce( "AchVersusAI" )
			end
		end
	end

end

function IsDefaultSettings()
	if GetConfigOptionValue({ Name = "LocalMPUseItems" }) then
		return false
	end
	if GetConfigOptionValue({ Name = "LocalMPCharacterLevel" }) > 0 then
		return false
	end
	if GetConfigOptionValue({ Name = "LocalMPTeamAPyreHealth" }) ~= 100 then
		return false
	end
	if GetConfigOptionValue({ Name = "LocalMPTeamBPyreHealth" }) ~= 100 then
		return false
	end
	if not GetConfigOptionValue({ Name = "LocalMPHumanTeamA" }) then
		return false
	end

	return true
end

function IsUsingCharacters( winningTeam, name1, name2, name3 )
	char1 = false
	char2 = false
	char3 = false
	if name3 == nil then
		char3 = true
	end
	for k, v in pairs( winningTeam.TeamBench ) do
		if v.ActiveStatus == "PlayedLastMatch" then
			if v.FirstName == name1 then
				char1 = true
			end
			if v.FirstName == name2 then
				char2 = true
			end
			if v.FirstName == name3 then
				char3 = true
			end
		end
	end
	if char1 and char2 and char3 then
		return true
	else
		return false
	end
end

function MakeScreenRelativeAndCenter( objects, center, screenRelativeOffsetX, screenRelativeOffsetY )

	if screenRelativeOffsetX == nil then
		screenRelativeOffsetX = 0
	end
	if screenRelativeOffsetY == nil then
		screenRelativeOffsetY = 0
	end

	for k, v in pairs( objects ) do
		DrawScreenRelative({ Id = v })
		--Teleport({ Id = v, DestinationId = center, DestinationIsScreenRelative = true, OffsetX = screenRelativeOffsetX, OffsetY = screenRelativeOffsetY })
		Teleport({ Id = v, DestinationId = center, DestinationIsScreenRelative = false, OffsetX = screenRelativeOffsetX, OffsetY = screenRelativeOffsetY })
	end
end

function AssignCharacterPostMatchSlot( team, character, slot )

	if character == nil then
		return
	end

	local victoryScreenPortrait = character.VictoryScreenPortrait
	if forfeitMatch and character.ForfeitVictoryScreenPortrait ~= nil then
		victoryScreenPortrait = character.ForfeitVictoryScreenPortrait
	end

	local colorObject = team
	if character.MaskHue ~= nil then
		colorObject = character
	end

	SetMenuOptions({ Name = "PostMatchScreen", Item = "Character"..slot,
		Properties =
		{
			FadeTarget = 1.0, Graphic = victoryScreenPortrait,
			MaskHue = colorObject.MaskHue, MaskSaturationAddition = colorObject.MaskSaturationAddition,
			MaskValueAddition = colorObject.MaskValueAddition,
			MaskHue2 = colorObject.MaskHue2, MaskSaturationAddition2 = colorObject.MaskSaturationAddition2,
			MaskValueAddition2 = colorObject.MaskValueAddition2,
		},
	})

	if slot == 2 then
		SetMenuOptions({ Name = "PostMatchScreen", Item = "Character"..slot, Properties = { MoveTargetShiftX = 100 } })
		if character.Archetype == "PlayerMedium" or character.Archetype == "PlayerMediumAlt" then
			SetMenuOptions({ Name = "PostMatchScreen", Item = "Character"..slot, Properties = { FlipHorizontal = false } })
		end
	elseif slot == 3 then
		SetMenuOptions({ Name = "PostMatchScreen", Item = "Character"..slot, Properties = { MoveTargetShiftX = -100 } })
		if character.Archetype == "PlayerMedium" or character.Archetype == "PlayerMediumAlt" then
			SetMenuOptions({ Name = "PostMatchScreen", Item = "Character"..slot, Properties = { FlipHorizontal = true } })
		end
	elseif slot == 1 then
		SetMenuOptions({ Name = "PostMatchScreen", Item = "Character"..slot, Properties = { MoveTargetShiftY = -100 } })
	end

end

function CloseMatchConclusionPresentation( )
	--AdjustFullscreenBloom({ Name = "Subtle", Duration = 0.3 })
	RemoveWorldText({ DestinationId = matchConclusionCenter, Duration = 0.3 })
	RemoveWorldText({ DestinationId = victoryTextAnchor, Duration = 0.3 })
	SetOpacity({ Ids = { hugeWheel, knockback, }, Fraction = 0, Delay = 0.1, Duration = 0.3 })

	Destroy({ Ids = { hugeWheel, knockback }, Delay = 0.6 })
	PlaySound({ Name = "/SFX/World Sounds/MapZoomInTight" })
	for k, v in pairs( ConcludingBench ) do
		SetMenuOptions({ Name = "PostMatchScreen", Item = "Character"..k, Properties = { FadeTarget = 0.0 } })
	end
	SetMenuOptions({ Name = "PostMatchScreen", Item = "Foreground", Properties = { FadeTarget = 0.0 } })


	Destroy({ Id = victorySparklesC })

	for k, id in pairs( VictoryScreenElements ) do
		SetOpacity( { Id = id, Fraction = 0, Duration = 0.43 } )
		--wait(0.03)
	end

	wait(0.4)

	ExitMenu({ Name = "PostMatchScreen" })
end

OnKeyPressed{"ControlAlt B",
	function(triggerArgs)
		SetPostMatchActiveStatus( TeamA, TeamB )
		--MatchConclusionPresentation( "Defeat" )
		--wait(1.0)
		MatchConclusionPresentation( "Victory" )
	end
}